Bug 1798811 - Review Request: waybar - Highly customizable Wayland bar for Sway and Wlroots based compositors
Summary: Review Request: waybar - Highly customizable Wayland bar for Sway and Wlroots...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Till Hofmann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-02-06 04:22 UTC by Aleksei Bavshin
Modified: 2020-02-20 05:03 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-02-09 22:46:13 UTC
Type: ---
thofmann: fedora-review+


Attachments (Terms of Use)

Description Aleksei Bavshin 2020-02-06 04:22:00 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/alebastr/waybar/fedora-rawhide-x86_64/01212492-waybar/waybar.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/alebastr/waybar/fedora-rawhide-x86_64/01212492-waybar/waybar-0.9.0-3.fc32.src.rpm
COPR URL: https://copr.fedorainfracloud.org/coprs/alebastr/waybar/

Description:
Waybar is a highly customizable Wayland bar for Sway and Wlroots based compositors.
Fedora Account System Username: alebastr

I've been contributing to upstream project and maintaining copr repo with waybar for about a year and increasing amount of complains about lack of the package in official Fedora repository has brought me here.
Since this is my first Fedora package I'm seeking a sponsor.

Notes to reviewers:
 - Changelog and Release from copr will be reset on import
 - Upstream has no better description for the project and most of the other distribution packagers didn't write one.
 - There's an upcoming upstream release, but it will introduce dependency on https://github.com/HowardHinnant/date/ which is a pain to package. I'd prefer to have one pending review at a time.

Comment 1 Jan Staněk 2020-02-06 15:27:09 UTC
Not a proper review, just my 2 cents:

> Source0:        %{url}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz
With github, there is no need to use the #-renaming trick for tarballs.
Prefer `SourceN:  %{url}/archive/%{version}/%{name}-%{version}.tar.gz`.
https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/#_git_hosting_services

> # disable systemd user service by default
Maybe I'm missing something, but any service in Fedora is not enabled by default; AFAIK you need a preset file only if you want to enable it without user interaction. Unless you have a compelling reason (in which case I would appreciate a comment in the spec file) to ship the preset, just get rid of it entirely.

Also, the unit file presumes the existence of a wayland-session.target, which we do not have in Fedora at the moment – so enabling the service would not have the desired effect of starting the service at login (as far as I can tell). I'm not sure what should be done with that.

---

Other than that, it looks good at a glance; thank you for the effort in preparing the package.

Comment 2 Aleksei Bavshin 2020-02-06 17:10:04 UTC
(In reply to Jan Staněk from comment #1)
> With github, there is no need to use the #-renaming trick for tarballs.
> Prefer `SourceN:  %{url}/archive/%{version}/%{name}-%{version}.tar.gz`.
> https://docs.fedoraproject.org/en-US/packaging-guidelines/SourceURL/#_git_hosting_services
Noted, will be changed in next update.

> Maybe I'm missing something, but any service in Fedora is not enabled by default;
Unfortunately user sevices are enabled by default. There's no global preset, however there's a plan to add it in f32: https://fedoraproject.org/wiki/Changes/Systemd_presets_for_user_units
I'm tracking that effort and will add proper conditionals once the change lands into fedora-release for f32.
You are right though, I need to update a comment with a reference to that change.

> Also, the unit file presumes the existence of a wayland-session.target,
> which we do not have in Fedora at the moment – so enabling the service would
> not have the desired effect of starting the service at login (as far as I
> can tell). I'm not sure what should be done with that.
I'll check that.
One thing I found with mako and redshift is that WantedBy=default.target starts services too early and does not get environment from sway. Right now I'm using custom sway-session.target and starting it from sway config as `exec 'systemctl --user import-environment; systemctl --user start sway-session.target'`, but that doesn't seem to be upstreamable.

Comment 3 Till Hofmann 2020-02-07 08:58:49 UTC
Thanks Jan for having a look at the package already.

For the user service preset, can you please add a comment and a link to the F32 change to the spec. This makes it obvious what's going on and is also a reminder to remove the preset once the change is accepted.

Is it possible to start waybar simply with something like `exec waybar`? If so, you could also remove the service all together until a proper solution was found. You should probably not include a service that does not work as expected.

Other than that, the SPEC looks nice and clean! Running fedora-review also didn't show any obvious problems. I'll follow up with a formal review once the above issues are addressed.

Comment 4 Aleksei Bavshin 2020-02-07 09:43:57 UTC
waybar could be started from sway-bar(5) swaybar_command or with `exec`. Systemd user service is not really necessary for that case, so I'm removing it for now.
It might become a problem in a future, once I fix everything required for StatusNotifierItem tray dbus activation and add dbus service. Hopefully we'll figure out how to mix sway and systemd user services by that moment.

Updated package:
Spec URL: https://copr-be.cloud.fedoraproject.org/results/alebastr/waybar/srpm-builds/01224084/waybar.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/alebastr/waybar/srpm-builds/01224084/waybar-0.9.0-4.fc31.src.rpm

Comment 5 Till Hofmann 2020-02-08 08:54:21 UTC
Looks good, approved!

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[?]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: %config files are marked noreplace or the reason is justified.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: No %config files under /usr.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: waybar-0.9.0-4.fc32.x86_64.rpm
          waybar-debuginfo-0.9.0-4.fc32.x86_64.rpm
          waybar-debugsource-0.9.0-4.fc32.x86_64.rpm
          waybar-0.9.0-4.fc32.src.rpm
4 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (debuginfo)
-------------------
Checking: waybar-debuginfo-0.9.0-4.fc32.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
perl: warning: Setting locale failed.
perl: warning: Please check that your locale settings:
	LANGUAGE = (unset),
	LC_ALL = (unset),
	LC_CTYPE = "C.UTF-8",
	LANG = "en_US.UTF-8"
    are supported and installed on your system.
perl: warning: Falling back to the standard locale ("C").
waybar.x86_64: W: invalid-url URL: https://github.com/Alexays/Waybar <urlopen error [Errno -2] Name or service not known>
waybar-debuginfo.x86_64: W: invalid-url URL: https://github.com/Alexays/Waybar <urlopen error [Errno -2] Name or service not known>
waybar-debugsource.x86_64: W: invalid-url URL: https://github.com/Alexays/Waybar <urlopen error [Errno -2] Name or service not known>
3 packages and 0 specfiles checked; 0 errors, 3 warnings.



Source checksums
----------------
https://github.com/Alexays/Waybar/archive/0.9.0/waybar-0.9.0.tar.gz :
  CHECKSUM(SHA256) this package     : 65e8397d5a8880cbb9172138e361b0d91f649bc99327d36945e38d1e5dbb157d
  CHECKSUM(SHA256) upstream package : 65e8397d5a8880cbb9172138e361b0d91f649bc99327d36945e38d1e5dbb157d


Requires
--------
waybar (rpmlib, GLIBC filtered):
    config(waybar)
    libc.so.6()(64bit)
    libdbusmenu-gtk3.so.4()(64bit)
    libfmt.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libgdk-3.so.0()(64bit)
    libgdkmm-3.0.so.1()(64bit)
    libgio-2.0.so.0()(64bit)
    libgiomm-2.4.so.1()(64bit)
    libglib-2.0.so.0()(64bit)
    libglibmm-2.4.so.1()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgtk-3.so.0()(64bit)
    libgtk-layer-shell.so.0()(64bit)
    libgtkmm-3.0.so.1()(64bit)
    libjsoncpp.so.22()(64bit)
    libm.so.6()(64bit)
    libmpdclient.so.2()(64bit)
    libmpdclient.so.2(libmpdclient2)(64bit)
    libnl-3.so.200()(64bit)
    libnl-3.so.200(libnl_3)(64bit)
    libnl-3.so.200(libnl_3_2_27)(64bit)
    libnl-genl-3.so.200()(64bit)
    libnl-genl-3.so.200(libnl_3)(64bit)
    libpthread.so.0()(64bit)
    libpulse.so.0()(64bit)
    libpulse.so.0(PULSE_0)(64bit)
    libsigc-2.0.so.0()(64bit)
    libspdlog.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.5)(64bit)
    libstdc++.so.6(CXXABI_1.3.9)(64bit)
    libudev.so.1()(64bit)
    libudev.so.1(LIBUDEV_183)(64bit)
    libwayland-client.so.0()(64bit)
    rtld(GNU_HASH)

waybar-debuginfo (rpmlib, GLIBC filtered):

waybar-debugsource (rpmlib, GLIBC filtered):



Provides
--------
waybar:
    config(waybar)
    waybar
    waybar(x86-64)

waybar-debuginfo:
    debuginfo(build-id)
    waybar-debuginfo
    waybar-debuginfo(x86-64)

waybar-debugsource:
    waybar-debugsource
    waybar-debugsource(x86-64)



Generated by fedora-review 0.7.4 (54fa030) last change: 2019-12-07
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -u https://bugzilla.redhat.com/show_bug.cgi?id=1798811
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, C/C++, Generic
Disabled plugins: Java, fonts, Ocaml, PHP, R, Haskell, SugarActivity, Python, Perl
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 6 Gwyn Ciesla 2020-02-08 19:18:19 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/waybar

Comment 7 Fedora Update System 2020-02-12 04:06:55 UTC
FEDORA-2020-7371874e98 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-7371874e98

Comment 8 Fedora Update System 2020-02-12 20:41:18 UTC
date-2.4.1-1.20200207git9a0ee25.fc31, waybar-0.9.1-1.fc31 has been pushed to the Fedora 31 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-7371874e98

Comment 9 Fedora Update System 2020-02-20 05:03:48 UTC
date-2.4.1-1.20200207git9a0ee25.fc31, waybar-0.9.1-1.fc31 has been pushed to the Fedora 31 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.